/*
 * 3D Engine 
 * display.h: 
 * Based on pikuma.com 3D software renderer in C
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 01/03/2021.
 */

#ifndef THREEDENGINE_SOURCE_INCLUDE_DISPLAY_H
#define THREEDENGINE_SOURCE_INCLUDE_DISPLAY_H

#include <SDL.h>

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/

extern SDL_Window *window;
extern SDL_Renderer *renderer;
extern uint32_t *frameBuffer;
extern SDL_Texture *frameBufferTexture;
extern int windowWidth;
extern int windowHeight;

/***********************************************************************************************************************
 * Prototypes
 **********************************************************************************************************************/

/* --- Window functions --- */
bool initialiseWindow(bool fullScreen);
void destroy_window();
void renderFrameBuffer();

/* --- Drawing functions --- */
void drawPixel(uint32_t x, uint32_t y, uint32_t colour);

void clearFrameBuffer(uint32_t colour);
void drawGrid(int spacing, uint32_t colour);
void drawRectangle(uint32_t x, uint32_t y, uint32_t w, uint32_t h, uint32_t colour);


#endif /* THREEDENGINE_SOURCE_INCLUDE_DISPLAY_H */
